using System;

namespace ConsoleApp1
{
    internal class Program
    {
        static void Main(string[] args)
        {
            ulong a, b;
            string[] red = Console.ReadLine().Split(' ');
            a = ulong.Parse(red[0]);
            b = ulong.Parse(red[1]);
            ulong[,] m = new ulong[a, b];
            ulong[,] memo = new ulong[a, b];
            bool[,] dozvoljena;
            for (ulong i = 0; i < a; i++)
            {
                red = Console.ReadLine().Split();
                for (ulong j = 0; j < b; j++)
                {
                    m[i, j] = ulong.Parse(red[j]);
                }
            }
            ulong n = ulong.Parse(Console.ReadLine());
            ulong p;
            ulong q;
            for (ulong k = 0; k < n; k++)
            {
                red = Console.ReadLine().Split(' ');
                p = ulong.Parse(red[0]) - 1;
                q = ulong.Parse(red[1]) - 1;
                dozvoljena = new bool[a, b];
                dozvoljena[p, q] = true;
                for (ulong i = 0; i < a; i++)
                {
                    for (ulong j = 0; j < b; j++)
                    {
                        if (i == 0 && j == 0)
                            memo[i, j] = m[i, j];
                        else if (i == 0)
                        {
                            memo[i, j] = m[i, j] + memo[i, j - 1];
                            if (dozvoljena[i, j - 1] == true)
                            {
                                dozvoljena[i, j] = true;
                            }
                        }
                        else if (j == 0)
                        {
                            memo[i, j] = m[i, j] + memo[i - 1, j];
                            if (dozvoljena[i - 1, j] == true)
                            {
                                dozvoljena[i, j] = true;
                            }
                        }
                        else
                        {
                            if (dozvoljena[i - 1, j] == false && dozvoljena[i, j - 1] == false)
                                memo[i, j] = m[i, j] + Math.Min(memo[i - 1, j], memo[i, j - 1]);
                            else if (dozvoljena[i - 1, j] == false)
                                memo[i, j] = m[i, j] + memo[i - 1, j];
                            else
                                memo[i, j] = m[i, j] + memo[i, j - 1];
                        }
                    }
                }
                Console.WriteLine(memo[a - 1, b - 1]);
            }
            
            Console.ReadLine();
        }
    }
}